SystemOrganization addCategory: #'TP2-Parte4'!
SystemOrganization addCategory: #'TP2-Parte4-Fixture'!

TestCase subclass: #TestTP2Parte4
	instanceVariableNames: 'claseAbuela clasePadre claseHija1 claseHija2 metodos clasePadreNueva objetitoDePrueba'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'!

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/4/2013 22:01'!
crearClasesPersonaHombreYMujer
	
	Object subclass: #Persona
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
	
	(Smalltalk at: #Persona) compile: 
	'nivelDeLevante
	"Decimos que por naturaleza, todos tenemos un nivel de levante mnimo"
	^20'.
	
	(Smalltalk at: #Persona) compile: 
	'decimeUnNumeroDelUnoAlDiez
	^7'.
			
	(Smalltalk at: #Persona) subclass: #Hombre
	instanceVariableNames: 'nivelFisico confianza'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
		
	(Smalltalk at: #Hombre) compile: 
	'nivelFisico
	^nivelFisico'.
	(Smalltalk at: #Hombre) compile: 
	'nivelFisico: unNivel
	"Debera ser del 1 al 100
	Si es 0, es un tanque australiano con poco levante.
	Si es 100, es un monstruo gigante con poco levante.
	Si es 50, es perfecto."
	nivelFisico := unNivel'.
	
	(Smalltalk at: #Hombre) compile: 
	'confianza
	^confianza'.
	(Smalltalk at: #Hombre) compile: 
	'confianza: unNivel
	"Debera ser del 1 al 100
	Si es 0, es un tmido con poco levante.
	Si es 100, es un credo con poco levante.
	Si es 50, es perfecto."
	confianza := unNivel'.
	
	(Smalltalk at: #Hombre) compile: 
	'nivelDeLevante
	^super nivelDeLevante + 80 - (((self nivelFisico - 50 raisedTo: 2) + (self confianza - 50 raisedTo: 2)) / 62.5)'.
	
	(Smalltalk at: #Hombre) compile: 
	'leGusta: estaPersona
	"Supongamos que los hombres no quieren sentirse nada intimidados"
	^estaPersona nivelDeLevante < self nivelDeLevante'.
	
	
	(Smalltalk at: #Persona) subclass: #Mujer
	instanceVariableNames: 'nivelFisico confianza'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
	
	(Smalltalk at: #Mujer) compile: 
	'nivelFisico
	^nivelFisico'.
	(Smalltalk at: #Mujer) compile: 
	'nivelFisico: unNivel
	"Debera ser del 1 al 100
	Si es 0, es un tanque australiano con poco levante.
	Si es 100, es demasiado musculosa.
	Si es 80, es perfecta."
	nivelFisico := unNivel'.
	
	(Smalltalk at: #Mujer) compile: 
	'confianza
	^confianza'.
	(Smalltalk at: #Mujer) compile: 
	'confianza: unNivel
	"Debera ser del 1 al 100
	Si es 0, es una tmida tierna con algo de levante.
	Si es 100, es una creda y agrega un levante negativo.
	Si es 40, es perfecta."
	confianza := unNivel'.
	
	(Smalltalk at: #Mujer) compile: 
	'nivelDeLevante
	^super nivelDeLevante + 80 - (  (self nivelFisico - 80 raisedTo: 2) / 160    +    ((self confianza -  40 raisedTo: 2) / 40)  )'.
	
	(Smalltalk at: #Mujer) compile: 
	'leGusta: estaPersona
	"Supongamos que las mujeres deciden en base a la confianza en s mismas"
	^estaPersona nivelDeLevante > self confianza'.
	
! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/4/2013 01:52'!
setUp
	
	Object subclass: #ClaseAbuela
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
	
	(Smalltalk at: #ClaseAbuela) subclass: #ClasePadre
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
			
	(Smalltalk at: #ClasePadre) subclass: #ClaseHija1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
	
	(Smalltalk at: #ClasePadre) subclass: #ClaseHija2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
	
	(Smalltalk at: #ClasePadre) compile:
	'metodoParaRedefinicion
	^1'.
	
	(Smalltalk at: #ClaseHija1) compile:
	'metodoParaRedefinicion
	^super metodoParaRedefinicion * 2'.
	
	(Smalltalk at: #ClaseHija1) compile:
	'metodoSencillo
	^1'.
	
	self crearClasesPersonaHombreYMujer.
! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/4/2013 02:55'!
tearDown
	(Smalltalk at: #ClaseAbuela) removeFromSystem.
	(Smalltalk at: #ClasePadre) removeFromSystem.
	(Smalltalk at: #ClaseHija1) removeFromSystem.
	(Smalltalk at: #ClaseHija2) removeFromSystem.
	(Smalltalk includesKey: #ClasePadreConMetodosRedefinidos)
		ifTrue: [(Smalltalk at: #ClasePadreConMetodosRedefinidos) removeFromSystem].
	(Smalltalk includesKey: #Persona)
		ifTrue: [(Smalltalk at: #Persona) removeFromSystem].
	(Smalltalk includesKey: #Hombre)
		ifTrue: [(Smalltalk at: #Hombre) removeFromSystem].
	(Smalltalk includesKey: #Mujer)
		ifTrue: [(Smalltalk at: #Mujer) removeFromSystem].
	(Smalltalk includesKey: #PersonaConMetodosRedefinidos )
		ifTrue: [(Smalltalk at: #PersonaConMetodosRedefinidos) removeFromSystem].
	
	
! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/4/2013 03:36'!
test1SubirNivelDeHerenciaDeSubclases
	|subclases|
	
	subclases := (Smalltalk at: #ClasePadre) subclasses.
	
	HerenciaAComposicion subirUnNivelDeHerenciaDeSubclasesDe: (Smalltalk at: #ClasePadre).
	
	self assert: (subclases allSatisfy: [:unaSubclase | unaSubclase superclass = (Smalltalk at: #ClasePadre) superclass]).
	
! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/4/2013 18:58'!
test2SubirNivelDeHerenciaDeSubclasesYProbarMetodoSencillo
	
	HerenciaAComposicion subirUnNivelDeHerenciaDeSubclasesDe: (Smalltalk at: #ClasePadre).
	
	objetitoDePrueba := (Smalltalk at: #ClaseHija1) new.
	
	self assert: (Smalltalk at: #ClaseHija1) superclass = (Smalltalk at: #ClasePadre) superclass & ((objetitoDePrueba metodoSencilloCon: ClasePadre new) = 1).
	
! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/4/2013 03:37'!
test3PasarHerenciaAComposicionYProbarMetodoDesdeLaExClaseAbstracta
		
	HerenciaAComposicion pasarHerenciaAComposicionEn: (Smalltalk at: #ClasePadre).
	
	"La clase hija 1 ya no es hija de clase padre, pero ahora la usamos para componer"
	objetitoDePrueba := (Smalltalk at: #ClasePadre) new.
	objetitoDePrueba variableDeComposicion: (Smalltalk at: #ClaseHija1) new.
	
	"Ahora debera entender el mensaje, debido a que internamete se lo delega a la composicin"
	self assert: objetitoDePrueba metodoSencillo = 1.
	
! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/4/2013 03:37'!
test4CrearNuevoPadreParaUnasSubclases
	"Este test es la previa para cuando se redefinen mtodos"
		
	clasePadreNueva := HerenciaAComposicion obtenerNuevoPadreParaLasSubclasesDe: (Smalltalk at: #ClasePadre).
	
	self assert: clasePadreNueva name = ((Smalltalk at: #ClasePadre) name, 'ConMetodosRedefinidos').! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/4/2013 03:38'!
test5DetectarSiExistenMetodosRedefinidos
	
	self assert: (HerenciaAComposicion tienenMetodosRedefinidosLasSubclasesDe: (Smalltalk at: #ClasePadre)).! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/4/2013 19:04'!
test6PasarHerenciaAComposicionYProbarMetodoRedefinido
	
	HerenciaAComposicion pasarHerenciaAComposicionEn: (Smalltalk at: #ClasePadre).
	
	objetitoDePrueba := (Smalltalk at: #ClaseHija1) new.
	
	"metodoParaRedefinicion usa el mtodo de la superclase. Si anda, es porque se pas bien el mtodo a la nueva superclase"
	self assert: (Smalltalk at: #ClaseHija1) superclass ~= Object &
				((objetitoDePrueba metodoParaRedefinicionCon: (Smalltalk at: #ClasePadre) new) = 2).
	
! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/4/2013 22:01'!
test7PasarHerenciaAComposicionConEstadosInternos
	
	|agrandada looser tipoDePersona leGustaAnterior|
	
	looser := (Smalltalk at: #Hombre) new.
	looser confianza: 0.
	looser nivelFisico: 0.
	
	agrandada := (Smalltalk at: #Mujer) new.
	agrandada confianza: 100.
	agrandada nivelFisico: 80.
	
	leGustaAnterior := agrandada leGusta: looser.
	
	HerenciaAComposicion pasarHerenciaAComposicionEn: (Smalltalk at: #Persona).
	"Esto me separa las subclases Hombre y Mujer"
	
	"Ahora hacemos PERSONAS en vez de una de las anteriores subclases"
	looser := (Smalltalk at: #Persona) new.
	looser variableDeComposicion: (Smalltalk at: #Hombre) new.
	looser confianza: 0.
	looser nivelFisico: 0.
	
	agrandada := (Smalltalk at: #Persona) new.
	agrandada variableDeComposicion: (Smalltalk at: #Mujer) new.
	agrandada confianza: 100.
	agrandada nivelFisico: 80.
	
	"Ahora vemos si se resuelve bien la delegacin de responsabilidades a la variable compuesta"
	self assert: leGustaAnterior = (agrandada leGusta: looser).
	
! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/4/2013 22:01'!
test8PasarHerenciaAComposicionYProbarMetodosDeDistintasClases
	
	|capo|
	
	HerenciaAComposicion pasarHerenciaAComposicionEn: (Smalltalk at: #Persona).
	"Esto me separa las subclases Hombre y Mujer"
	
	"Ahora hacemos PERSONAS en vez de una de las anteriores subclases"
	capo := (Smalltalk at: #Persona) new.
	capo variableDeComposicion: (Smalltalk at: #Hombre) new.
	capo confianza: 50.
	capo nivelFisico: 50.
	
	"Ahora invocamos un mtodo que se defini en la clase Persona a ver si sigue andando"
	self assert: capo decimeUnNumeroDelUnoAlDiez = 7.
	
! !

Object subclass: #HerenciaAComposicion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'!

!HerenciaAComposicion class methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/4/2013 18:40'!
agregarSelfAlNombreDelMetodo: selector
	|nombre|
	(selector endsWith: ':')
	ifTrue:
		[nombre := 'segun: anObject ',selector]
	ifFalse:
		[nombre := selector, 'segun: anObject'].
	^nombre.

	
	! !

!HerenciaAComposicion class methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/4/2013 16:41'!
agregarVariableALaClase: estaClase anteEstosMetodos: unosMetodos.

	estaClase addInstVarNamed: 'variableDeComposicion'. "Nombre medio largo y poco expresivo para que sea poco probable que ya exista"
	estaClase compile:
		'variableDeComposicion: unObjeto
		variableDeComposicion := unObjeto'.
	estaClase compile:
		'variableDeComposicion
		^variableDeComposicion'.
		
	unosMetodos do: [:unMetodo | self ponerMetodo: unMetodo QueAccedeAVariableCompuestaDesde: estaClase].
	! !

!HerenciaAComposicion class methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/4/2013 16:47'!
hacerQueLasSubclasesDe: estaClase heredenDe: estePadre
	
	|metodos clases|
	clases := estaClase subclasses.
	metodos := clases gather: [:unaSubclase| unaSubclase methods].
	
	clases do: [:unaSubclase |unaSubclase superclass: estePadre. estePadre addSubclass: unaSubclase. estaClase removeSubclass: unaSubclase].
	
	self agregarVariableALaClase: estaClase anteEstosMetodos: metodos.
	
	self redefinirMetodosParaPoderUsarComoStrategyA: clases.! !

!HerenciaAComposicion class methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/4/2013 17:07'!
obtenerNuevoPadreParaLasSubclasesDe: estaClase
	|nombre|
	nombre := estaClase name.
	
	nombre := nombre,'ConMetodosRedefinidos'.
	
	^(Object subclass: nombre asSymbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4')
	! !

!HerenciaAComposicion class methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/4/2013 18:57'!
pasarHerenciaAComposicionEn: estaClase
	|nuevoPadre|
	(self tienenMetodosRedefinidosLasSubclasesDe: estaClase)
		ifTrue:
			[	
			nuevoPadre := self obtenerNuevoPadreParaLasSubclasesDe: estaClase.
			self pasarMetodosRedefinidosDeSubclasesDe: estaClase a: nuevoPadre.]
		ifFalse:
			[nuevoPadre := (Smalltalk at: #Object)].
		self hacerQueLasSubclasesDe: estaClase heredenDe: nuevoPadre.
		
		
		
		
		
		
		
	! !

!HerenciaAComposicion class methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 02:44'!
pasarMetodosRedefinidosDeSubclasesDe: estaClase a: nuevoPadre
	|metodos|
	metodos := estaClase methods select: [:metodo | metodo isOverriden].	
	metodos do: [:metodo | nuevoPadre compile: metodo].! !

!HerenciaAComposicion class methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/4/2013 18:51'!
ponerMetodo: unMetodo QueAccedeAVariableCompuestaDesde: estaClase

	|cantDeArgumentos argumentos indice palabrasDelSelector nombreCompletoSelector nombreSelectorConSelf cantCaracteres|
	
	cantDeArgumentos := unMetodo numArgs.
	
	argumentos := OrderedCollection new.
	
	"Obtengo todos los argumentos y les pongo nombre"
	indice := 1.
	[ cantDeArgumentos  >= indice ] whileTrue: 
	[ argumentos add: 'anObject',indice asString,' '.
	indice := indice + 1 ].
	
	"Obtengo cada palabra del nombre del mtodo"
	palabrasDelSelector := unMetodo selector asString keywords.
	
	"Le enchufo los argumentos"
	nombreCompletoSelector := ''.
	palabrasDelSelector do: [:palabra |
		indice := palabrasDelSelector indexOf: palabra.
		nombreCompletoSelector := nombreCompletoSelector , palabra.
		(palabra endsWith: ':')
			ifTrue: [nombreCompletoSelector := nombreCompletoSelector, (argumentos at: indice)] ].
	
	"Le agrego lo de pasarme a m mismo como parmetro"
	(unMetodo numArgs = 0)
		ifTrue:[ "Le agrego al mtodo lo de pasarme, al final"
			cantCaracteres := nombreCompletoSelector size.
			nombreSelectorConSelf := nombreCompletoSelector,'Con: self'.
			]
		ifFalse: [ "Le agrego al mtodo lo de pasarme, al principio"
			nombreSelectorConSelf := 'segun: self ',nombreCompletoSelector.
			].
	
	estaClase compile:
		nombreCompletoSelector,'
		^self variableDeComposicion ', nombreSelectorConSelf.
	
	! !

!HerenciaAComposicion class methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/4/2013 19:40'!
redefinirMetodosParaPoderUsarComoStrategyA: unasClases
	
		|codigo nombre cantCaracteres |
		
	"Cambio los encabezados de los mtodos para que funcione lo anterior"	
	unasClases do: [:unaClase | unaClase methods do:[ :unMetodo |
				codigo := unMetodo getSource.
				
				(unMetodo numArgs = 0)
				ifTrue:[ "Le agrego al mtodo lo de pasarle el objeto desde donde lo invoqu, al final"
					nombre := codigo subStrings at: 1.
					cantCaracteres := nombre size.
					nombre := nombre,'Con: anObject'.
					codigo := codigo copyFrom: cantCaracteres + 1 to: codigo size.
					codigo := nombre,codigo.
					]
				ifFalse: [ "Le agrego al mtodo lo de pasarle el objeto desde lo invoqu, al principio"
					codigo := 'segun: anObject ',codigo.
					].
				unaClase removeSelector: unMetodo selector.
				unaClase compile: codigo.
				]
			].
		
	"Cambio las llamadas a self por llamadas al objeto que me invoc"	
	unasClases do: [:unaClase | unaClase methods do:[ :unMetodo |
			codigo := unMetodo getSource.
			codigo := codigo copyReplaceTokens: 'self' with: 'anObject'.
			unaClase compile: codigo.
			]
		].! !

!HerenciaAComposicion class methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 03:35'!
subirUnNivelDeHerenciaDeSubclasesDe: estaClase
	
	self hacerQueLasSubclasesDe: estaClase heredenDe: estaClase superclass.
! !

!HerenciaAComposicion class methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 02:28'!
tienenMetodosRedefinidosLasSubclasesDe: estaClase
	
	^estaClase subclasses anySatisfy: [:unaSubclase | unaSubclase methods anySatisfy: [:m1 | m1 isOverride]].
		! !
